/*
  Akana R1 Demo v1

  Demo code using the buttons, LEDs, and OLED display for METE HOCA Akana R1
  
  Board : METE HOCA Akana R1
  Dock  : -
  Core  : earlephilhower / arduino-pico (https://github.com/earlephilhower/arduino-pico)
  Required Libraries : U8G2 (https://github.com/olikraus/u8g2)
  Settings : Select METE HOCA Akana R1 as the board.
	     Set the I2C selector to the I2C0 position.

  Source: METE HOCA
  
  METE HOCA, 19 May 2024
  IG : https://www.instagram.com/metehoca/
  YT : https://www.youtube.com/MeteHoca
  WEB: https://www.metehoca.com/
*/

#include "Akana.h"

const char* menuTitle = "Akana R1 Demo";
unsigned long previousMillis = 0;

void setup() {
  u8g2.begin();
  u8g2.setFont(u8g2_font_6x12_me);
  u8g2.setFontMode(1);
  u8g2.setDrawColor(1);
  u8g2.setFontPosTop();
  u8g2.setContrast(255);

  pinMode(BTN_UP, INPUT);
  pinMode(BTN_DOWN, INPUT);
  pinMode(BTN_LEFT, INPUT);
  pinMode(BTN_RIGHT, INPUT);
  pinMode(BTN_BACK, INPUT);
  pinMode(BTN_ENTER, INPUT);

  pinMode(LED_BUILTIN, OUTPUT);

  logoAkana();
}

void loop() {
  u8g2.clearBuffer();
  u8g2.drawUTF8(((128 - (u8g2.getUTF8Width(menuTitle))) / 2), 2, menuTitle);
  
  if (digitalRead(BTN_UP)) u8g2.drawRBox(15,15,16,16,5); else u8g2.drawRFrame(15,15,16,16,5);
  if (digitalRead(BTN_DOWN)) u8g2.drawRBox(15,47,16,16,5); else u8g2.drawRFrame(15,47,16,16,5);
  if (digitalRead(BTN_LEFT)) u8g2.drawRBox(0,31,16,16,5); else u8g2.drawRFrame(0,31,16,16,5);
  if (digitalRead(BTN_RIGHT)) u8g2.drawRBox(31,31,16,16,5); else u8g2.drawRFrame(31,31,16,16,5);
  if (digitalRead(BTN_ENTER)) u8g2.drawRBox(111,23,16,16,5); else u8g2.drawRFrame(111,23,16,16,5);
  if (digitalRead(BTN_BACK)) u8g2.drawRBox(80,47,16,16,5); else u8g2.drawRFrame(80,47,16,16,5);
  
  unsigned long currentMillis = millis();
  if (currentMillis - previousMillis >= 500) {
    previousMillis = currentMillis;
    digitalToggle(LED_BUILTIN);
  }
  if (digitalRead(LED_BUILTIN))
    u8g2.drawRBox(80,23,16,8,3);
  else
    u8g2.drawRFrame(80,23,16,8,3);
  u8g2.sendBuffer();
}