/*
  Akana R1 AkanaFlake v1

  Screen Saver Code for METE HOCA Akana R1
  
  Board : METE HOCA Akana R1
  Dock : -
  Core: earlephilhower / arduino-pico (https://github.com/earlephilhower/arduino-pico)
  Required Libraries: Adafruit SSD1306 (https://github.com/adafruit/Adafruit_SSD1306)
                      Adafruit GFX (https://github.com/adafruit/Adafruit-GFX-Library)
  Settings: Select METE HOCA Akana R1 as the board.
		   Set the I2C selector to the I2C0 position.

  Source: Adafruit/METE HOCA
  
  METE HOCA, 19 May 2024
  IG : https://www.instagram.com/metehoca/
  YT : https://www.youtube.com/MeteHoca
  WEB: https://www.metehoca.com/
*/
 
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

Adafruit_SSD1306 display(128, 64, &Wire, -1);

#define NUMFLAKES     20
#define XPOS   0
#define YPOS   1
#define DELTAY 2
int8_t f, icons[NUMFLAKES][6];

static const unsigned char PROGMEM logo_bmp[] = {
0x01, 0x00, 0x01, 0x80, 0x01, 0x80, 0x03, 0xC0,
0x03, 0xC0, 0x03, 0xC0, 0x06, 0x60, 0x06, 0x60,
0x2E, 0x70, 0x3C, 0x30, 0x1E, 0x30, 0x1F, 0xD8,
0x19, 0xF8, 0x30, 0x7C, 0x30, 0x1C, 0x70, 0x06};

void setup() {
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);

  for(f=0; f< NUMFLAKES; f++) {
    icons[f][XPOS]   = random(1 - 16, display.width());
    icons[f][YPOS]   = -16;
    icons[f][DELTAY] = random(1, 6);
  }
}

void loop() {
  display.clearDisplay();

  for(f=0; f< NUMFLAKES; f++) display.drawBitmap(icons[f][XPOS], icons[f][YPOS], logo_bmp, 16, 16, SSD1306_WHITE);
  display.display();
  delay(33);

  for(f=0; f< NUMFLAKES; f++) {
    icons[f][YPOS] += icons[f][DELTAY];
    if (icons[f][YPOS] >= display.height()) {
      icons[f][XPOS]   = random(1 - 16, display.width());
      icons[f][YPOS]   = -16;
      icons[f][DELTAY] = random(1, 6);
    }
  }
}